org.python.core

## Class PySequenceList

- java.lang.Object
- - org.python.core.PyObject
  - - org.python.core.PySequence
    - - org.python.core.PySequenceList

All Implemented Interfaces:
  java.io.Serializable, java.lang.Iterable, java.util.Collection, java.util.List, Traverseproc

Direct Known Subclasses:
  PyList, PyTuple

    public abstract class PySequenceList
    extends PySequence
    implements java.util.List, Traverseproc

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.python.core.PyObject

`PyObject.ConversionException`

### Field Summary

### Fields inherited from class org.python.core.PyObject

`gcMonitorGlobal, TYPE`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract void` `add(int index, java.lang.Object element)`
`abstract boolean` `add(java.lang.Object o)`
`abstract boolean` `addAll(java.util.Collection c)`
`abstract boolean` `addAll(int index, java.util.Collection c)`
`abstract void` `clear()`
`abstract boolean` `contains(java.lang.Object o)`
`abstract boolean` `containsAll(java.util.Collection c)`
`abstract boolean` `equals(java.lang.Object o)` Should almost never be overridden.
`abstract java.lang.Object` `get(int index)`
`abstract PyObject[]` `getArray()` Get the backing array.
`abstract int` `hashCode()`
`abstract int` `indexOf(java.lang.Object o)`
`abstract boolean` `isEmpty()`
`abstract java.util.Iterator` `iterator()`
`abstract int` `lastIndexOf(java.lang.Object o)`
`abstract java.util.ListIterator` `listIterator()`
`abstract java.util.ListIterator` `listIterator(int index)`
`abstract void` `pyadd(int index, PyObject element)`
`abstract boolean` `pyadd(PyObject o)`
`abstract PyObject` `pyget(int index)` Returns the element of the sequence at the given index.
`abstract void` `pyset(int index, PyObject element)` Sets the indexed element of the sequence to the given value.
`boolean` `refersDirectlyTo(PyObject ob)` Optional operation.
`abstract java.lang.Object` `remove(int index)`
`abstract void` `remove(int start, int stop)`
`abstract boolean` `remove(java.lang.Object o)`
`abstract boolean` `removeAll(java.util.Collection c)`
`abstract boolean` `retainAll(java.util.Collection c)`
`abstract java.lang.Object` `set(int index, java.lang.Object element)`
`abstract int` `size()`
`abstract java.util.List` `subList(int fromIndex, int toIndex)`
`abstract java.lang.Object[]` `toArray()`
`abstract java.lang.Object[]` `toArray(java.lang.Object[] a)`
`abstract java.lang.String` `toString()`
`int` `traverse(Visitproc visit, java.lang.Object arg)` Traverses all directly contained `PyObject`s.

### Methods inherited from class org.python.core.PySequence

`__delitem__, __delslice__, __eq__, __finditem__, __finditem__, __ge__, __getitem__, __getslice__, __gt__, __iter__, __le__, __lt__, __ne__, __nonzero__, __setitem__, __setitem__, __setslice__, __tojava__, isMappingType, isNumberType, isSequenceType`

### Methods inherited from class org.python.core.PyObject

`__abs__, __add__, __and__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __call__, __cmp__, __coerce__, __coerce_ex__, __complex__, __contains__, __delattr__, __delattr__, __delete__, __delitem__, __delslice__, __dir__, __div__, __divmod__, __ensure_finalizer__, __findattr__, __findattr__, __findattr_ex__, __finditem__, __float__, __floordiv__, __format__, __get__, __getattr__, __getattr__, __getitem__, __getnewargs__, __getslice__, __hash__, __hex__, __iadd__, __iand__, __idiv__, __idivmod__, __ifloordiv__, __ilshift__, __imod__, __imul__, __index__, __int__, __invert__, __ior__, __ipow__, __irshift__, __isub__, __iternext__, __itruediv__, __ixor__, __len__, __long__, __lshift__, __mod__, __mul__, __neg__, __not__, __oct__, __or__, __pos__, __pow__, __pow__, __radd__, __rand__, __rdiv__, __rdivmod__, __reduce__, __reduce_ex__, __reduce_ex__, __repr__, __rfloordiv__, __rlshift__, __rmod__, __rmul__, __ror__, __rpow__, __rrshift__, __rshift__, __rsub__, __rtruediv__, __rxor__, __set__, __setattr__, __setattr__, __setitem__, __setslice__, __str__, __sub__, __truediv__, __trunc__, __unicode__, __xor__, _add, _and, _callextra, _cmp, _div, _divmod, _doget, _doget, _doset, _eq, _floordiv, _ge, _gt, _iadd, _iand, _idiv, _idivmod, _ifloordiv, _ilshift, _imod, _imul, _in, _ior, _ipow, _irshift, _is, _isnot, _isub, _itruediv, _ixor, _jcall, _jcallexc, _jthrow, _le, _lshift, _lt, _mod, _mul, _ne, _notin, _or, _pow, _rshift, _sub, _truediv, _xor, asDouble, asIndex, asIndex, asInt, asInt, asIterable, asLong, asLong, asName, asName, asString, asString, asStringOrNull, asStringOrNull, bit_length, conjugate, delDict, delType, dispatch__init__, fastGetClass, fastGetDict, getDict, getType, implementsDescrDelete, implementsDescrGet, implementsDescrSet, invoke, invoke, invoke, invoke, invoke, invoke, isCallable, isDataDescr, isIndex, isInteger, noAttributeError, object___subclasshook__, readonlyAttributeError, setDict, setType`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.util.List

`replaceAll, sort, spliterator`

### Methods inherited from interface java.util.Collection

`parallelStream, removeIf, stream`

### Methods inherited from interface java.lang.Iterable

`forEach`

### Method Detail

#### add

    public abstract void add(int index,
                             java.lang.Object element)

Specified by:
  `add` in interface `java.util.List`

#### add

    public abstract boolean add(java.lang.Object o)

Specified by:
  `add` in interface `java.util.Collection`
Specified by:
  `add` in interface `java.util.List`

#### addAll

    public abstract boolean addAll(int index,
                                   java.util.Collection c)

Specified by:
  `addAll` in interface `java.util.List`

#### addAll

    public abstract boolean addAll(java.util.Collection c)

Specified by:
  `addAll` in interface `java.util.Collection`
Specified by:
  `addAll` in interface `java.util.List`

#### clear

    public abstract void clear()

Specified by:
  `clear` in interface `java.util.Collection`
Specified by:
  `clear` in interface `java.util.List`

#### contains

    public abstract boolean contains(java.lang.Object o)

Specified by:
  `contains` in interface `java.util.Collection`
Specified by:
  `contains` in interface `java.util.List`

#### containsAll

    public abstract boolean containsAll(java.util.Collection c)

Specified by:
  `containsAll` in interface `java.util.Collection`
Specified by:
  `containsAll` in interface `java.util.List`

#### equals

    public abstract boolean equals(java.lang.Object o)

Description copied from class: `PyObject`
Should almost never be overridden. If overridden, it is the subclasses responsibility to ensure that `a.equals(b) == true` iff `cmp(a,b) == 0`

Specified by:
  `equals` in interface `java.util.Collection`
Specified by:
  `equals` in interface `java.util.List`
Overrides:
  `equals` in class `PyObject`

#### get

    public abstract java.lang.Object get(int index)

Specified by:
  `get` in interface `java.util.List`

#### getArray

    public abstract PyObject[] getArray()

Get the backing array. The array should not be modified. To get a copy of the array, see `toArray()`.

#### hashCode

    public abstract int hashCode()

Specified by:
  `hashCode` in interface `java.util.Collection`
Specified by:
  `hashCode` in interface `java.util.List`
Overrides:
  `hashCode` in class `PyObject`

#### indexOf

    public abstract int indexOf(java.lang.Object o)

Specified by:
  `indexOf` in interface `java.util.List`

#### isEmpty

    public abstract boolean isEmpty()

Specified by:
  `isEmpty` in interface `java.util.Collection`
Specified by:
  `isEmpty` in interface `java.util.List`

#### iterator

    public abstract java.util.Iterator iterator()

Specified by:
  `iterator` in interface `java.lang.Iterable`
Specified by:
  `iterator` in interface `java.util.Collection`
Specified by:
  `iterator` in interface `java.util.List`

#### lastIndexOf

    public abstract int lastIndexOf(java.lang.Object o)

Specified by:
  `lastIndexOf` in interface `java.util.List`

#### listIterator

    public abstract java.util.ListIterator listIterator()

Specified by:
  `listIterator` in interface `java.util.List`

#### listIterator

    public abstract java.util.ListIterator listIterator(int index)

Specified by:
  `listIterator` in interface `java.util.List`

#### pyadd

    public abstract void pyadd(int index,
                               PyObject element)

#### pyadd

    public abstract boolean pyadd(PyObject o)

#### pyget

    public abstract PyObject pyget(int index)

Description copied from class: `PySequence`
Returns the element of the sequence at the given index. This is an extension point called by PySequence in its implementation of `PySequence.__getitem__(org.python.core.PyObject)` It is guaranteed by PySequence that when it calls `pyget(int)` the index is within the bounds of the array. Any other clients must make the same guarantee.

Parameters:
  `index` - index of element to return.
Returns:
  the element at the given position in the list.

#### pyset

    public abstract void pyset(int index,
                               PyObject element)

Description copied from class: `PySequence`
Sets the indexed element of the sequence to the given value. This is an extension point called by PySequence in its implementation of `PySequence.__setitem__(int, org.python.core.PyObject)` It is guaranteed by PySequence that when it calls pyset(int) the index is within the bounds of the array. Any other clients must make the same guarantee.

Parameters:
  `index` - index of the element to set.
  `element` - the value to set this element to.

#### remove

    public abstract java.lang.Object remove(int index)

Specified by:
  `remove` in interface `java.util.List`

#### remove

    public abstract void remove(int start,
                                int stop)

#### remove

    public abstract boolean remove(java.lang.Object o)

Specified by:
  `remove` in interface `java.util.Collection`
Specified by:
  `remove` in interface `java.util.List`

#### removeAll

    public abstract boolean removeAll(java.util.Collection c)

Specified by:
  `removeAll` in interface `java.util.Collection`
Specified by:
  `removeAll` in interface `java.util.List`

#### retainAll

    public abstract boolean retainAll(java.util.Collection c)

Specified by:
  `retainAll` in interface `java.util.Collection`
Specified by:
  `retainAll` in interface `java.util.List`

#### set

    public abstract java.lang.Object set(int index,
                                         java.lang.Object element)

Specified by:
  `set` in interface `java.util.List`

#### size

    public abstract int size()

Specified by:
  `size` in interface `java.util.Collection`
Specified by:
  `size` in interface `java.util.List`

#### subList

    public abstract java.util.List subList(int fromIndex,
                                           int toIndex)

Specified by:
  `subList` in interface `java.util.List`

#### toArray

    public abstract java.lang.Object[] toArray()

Specified by:
  `toArray` in interface `java.util.Collection`
Specified by:
  `toArray` in interface `java.util.List`

#### toArray

    public abstract java.lang.Object[] toArray(java.lang.Object[] a)

Specified by:
  `toArray` in interface `java.util.Collection`
Specified by:
  `toArray` in interface `java.util.List`

#### toString

    public abstract java.lang.String toString()

Overrides:
  `toString` in class `PyObject`

#### traverse

    public int traverse(Visitproc visit,
                        java.lang.Object arg)

Description copied from interface: `Traverseproc`
Traverses all directly contained `PyObject`s. Like in CPython, `arg` must be passed unmodified to `visit` as its second parameter. If `Visitproc.visit(PyObject, Object)` returns nonzero, this return value must be returned immediately by traverse. `Visitproc.visit(PyObject, Object)` must not be called with a `null` PyObject-argument.

Specified by:
  `traverse` in interface `Traverseproc`

#### refersDirectlyTo

    public boolean refersDirectlyTo(PyObject ob)
                             throws java.lang.UnsupportedOperationException

Description copied from interface: `Traverseproc`
Optional operation. Should only be implemented if it is more efficient than calling `Traverseproc.traverse(Visitproc, Object)` with a visitproc that just watches out for `ob`. Must return `false` if `ob` is `null`.

Specified by:
  `refersDirectlyTo` in interface `Traverseproc`
Throws:
  `java.lang.UnsupportedOperationException`